#include "tkpict.h"

PictColorTable *PowColorTable;

extern Tcl_Interp *interp;

XColor lut_colorcell_defs[MAX_COLORS];


int convert_block_to_byte(void *in, unsigned char *out, int npts,
			  int in_type,double *dispmin, double *dispmax)
{
  register int i;
  double scale;
  unsigned char *ptr_out; 
  double holder;

  ptr_out = (unsigned char*)out;
  switch (in_type)
    { 
    case BYTE:
      {
        unsigned char *ptr = (unsigned char *)in;
	unsigned char max = *ptr++;
	unsigned char min = max;
		
	
	for (i=1;i<npts;++i,++ptr)
	  {
	    if (*ptr > max) max = *ptr;
	    else if (*ptr < min) min = *ptr;
	  }
	if( (*dispmin == 0.0) && (*dispmax == 0.0) ) 
	  {
	    *dispmin = min;
	    *dispmax = max;
	  }
	else {
	  /* Ummm.... why are we doing this.  Users frequently want
	     a displayed range smaller than actual, let's break it and
             see what happens */
	  /*	  
		  if (*dispmin>(double)min) 
		  *dispmin = min;
		  if (*dispmax<(double)max)
		  *dispmax = max;
	    */
	}
	ptr = in;
	if( (*dispmax-*dispmin) == 0.0 ) {
	  for (i=0;i<npts;++i)
	    *ptr_out++ = 127;
	}
	else {
	  scale = 255.0 / (*dispmax - *dispmin);
	  for (i=0;i<npts;++i) {
	    holder = scale * (*ptr++ - *dispmin);
	    holder = (holder >  255.0) ? 255.0: holder;
	    holder = (holder <  0.0) ? 0 : holder;
	    *ptr_out++ = holder;
	  }
	}
      }
      break;
    case WORD:
      {
        short *ptr = (short *)in;
	short max = *ptr++;
	short min = max;
		
	for (i=1;i<npts;++i,++ptr)
	  {
	    if (*ptr > max) max = *ptr;
	    else if (*ptr < min) min = *ptr;
	  }
	if( (*dispmin == 0.0) && (*dispmax == 0.0) ) 
	  {
	    *dispmin = min;
	    *dispmax = max;
	  }
	else {
	  /* Ummm.... why are we doing this.  Users frequently want
	     a displayed range smaller than actual, let's break it and
             see what happens */
	  /*	  
		  if (*dispmin>(double)min) 
		  *dispmin = min;
		  if (*dispmax<(double)max)
		  *dispmax = max;
	    */
	}
	ptr = in;
	if( (*dispmax-*dispmin) == 0.0 ) {
	  for (i=0;i<npts;++i)
	    *ptr_out++ = 127;
	}
	else {
	  scale = 255.0 / (*dispmax - *dispmin);
	  for (i=0;i<npts;++i) {
	    holder = scale * (*ptr++ - *dispmin);
	    holder = (holder >  255.0) ? 255.0: holder;
	    holder = (holder <  0.0) ? 0 : holder;
	    *ptr_out++ = holder;
	  }
	}
      }
      break;
    case LWORD:
      {
        int *ptr = (int *)in;
	int max = *ptr++;
	int min = max;

	for (i=1;i<npts;++i,++ptr)
	  {
	    if (*ptr > max) max = *ptr;
	    else if (*ptr < min) min = *ptr;
	  }
	if( (*dispmin == 0.0) && (*dispmax == 0.0) ) 
	  {
	    *dispmin = min;
	    *dispmax = max;
	  }
	else {
	  /* Ummm.... why are we doing this.  Users frequently want
	     a displayed range smaller than actual, let's break it and
             see what happens */
	  /*	  if (*dispmin>(double)min) 
	    *dispmin = min;
	  if (*dispmax<(double)max)
	    *dispmax = max;
	    */
	}
	ptr = in; 
	if( (*dispmax-*dispmin) == 0.0 ) {
	  for (i=0;i<npts;++i)
	    *ptr_out++ = 127;
	}
	else {
	  scale = 255.0 / (*dispmax - *dispmin);
	  for (i=0;i<npts;++i) {
	    holder = scale * (*ptr++ - *dispmin);
	    holder = (holder >  255.0) ? 255.0: holder;
	    holder = (holder <  0.0) ? 0 : holder;
	    *ptr_out++ = holder;
	  }
	}
      }
      break;
    case REAL:
      {
        float *ptr;
	float max;
	float min;

	ptr = (float *)in;
	max = *ptr++;
	min = max;
	
	for (i=1;i<npts;++i,++ptr)
	  {
	    if (*ptr > max) max = *ptr;
	    else if (*ptr < min) min = *ptr;
	  }
	if( (*dispmin == 0.0) && (*dispmax == 0.0) ) 
	  {
	    *dispmin = min;
	    *dispmax = max;
	  }
	else {
	  /* Ummm.... why are we doing this.  Users frequently want
	     a displayed range smaller than actual, let's break it and
             see what happens */
	  /*	  if (*dispmin>(double)min) 
	    *dispmin = min;
	  if (*dispmax<(double)max)
	    *dispmax = max;
	    */
	}
	ptr = (float*)in; 
	if( (*dispmax-*dispmin) == 0.0 ) {
	  for (i=0;i<npts;++i)
	    *ptr_out++ = 127;
	}
	else {
	  scale = 255.0 / (*dispmax - *dispmin);
	  for (i=0;i<npts;++i) {
	    holder = scale * (*ptr++ - *dispmin);
	    holder = (holder >  255.0) ? 255.0: holder;
	    holder = (holder <  0.0) ? 0 : holder;
	    *ptr_out++ = holder;
	  }
	}
      }
      break;
    case DOUBLE:
      {
        double *ptr;
	double max;
	double min;

	ptr = (double *)in;
	max = *ptr++;
	min = max;
	
	for (i=1;i<npts;++i,++ptr)
	  {
	    if (*ptr > max) max = *ptr;
	    else if (*ptr < min) min = *ptr;
	  }
	if( (*dispmin == 0.0) && (*dispmax == 0.0) ) 
	  {
	    *dispmin = min;
	    *dispmax = max;
	  }
	else {
	  /* Ummm.... why are we doing this.  Users frequently want
	     a displayed range smaller than actual, let's break it and
             see what happens */
	  /*	  if (*dispmin>(double)min) 
	    *dispmin = min;
	  if (*dispmax<(double)max)
	    *dispmax = max;
	    */
	}
	ptr = (double*)in; 
	if( (*dispmax-*dispmin) == 0.0 ) {
	  for (i=0;i<npts;++i)
	    *ptr_out++ = 127;
	}
	else {
	  scale = 255.0 / (*dispmax - *dispmin);
	  for (i=0;i<npts;++i) {
	    holder = scale * (*ptr++ - *dispmin);
	    holder = (holder >  255.0) ? 255.0: holder;
	    holder = (holder <  0.0) ? 0 : holder;
	    *ptr_out++ = holder;
	  }
	}
      }
      break;
    default:
      (void)fprintf(stderr,"Unknown data type %d\n",in_type);
      return(0);
    }

  /* (void)fprintf(stderr,"dispmin %g dispmax %g\n",*dispmin,*dispmax); */
  return(1);
} /* end convert_block_to_byte */



/* Copy new lut into cmap */
/* Copy ncolors colors from argument arrays to color cells, and
   load into cmap to change the colors on the X display */

void put_lut(Display *disp,Colormap cmap,
	     int ncolors,int lut_start,char overlay,
	     int *red,int *green,int *blue,
	     int *intensity_lut,int *red_lut,int *green_lut,int *blue_lut)
{
   int 	i,j;
   int index;
   int background_index;
   int mod_lstart;
   int pseudoImages;

#ifdef DEBUG
   printf("put_lut\n");
#endif

   if(overlay == False) {
     for (i=lut_start,j=0; j<ncolors; i++,j++) {
       index = intensity_lut[j];
       lut_colorcell_defs[i].pixel = i;
       lut_colorcell_defs[i].red   =  (unsigned short) (red_lut[red[index]]<<8) ;
       lut_colorcell_defs[i].green =  (unsigned short) (green_lut[green[index]]<<8) ;
       lut_colorcell_defs[i].blue  =  (unsigned short) (blue_lut[blue[index]]<<8) ;
       lut_colorcell_defs[i].flags = DoRed | DoBlue | DoGreen;
     }
   } else {
     mod_lstart = lut_start%2; /* helpful if we decide one day that lut_start should
				  be odd and not even as it is hard-coded now */
     for (i=lut_start,j=0; j<ncolors; i++,j++) {
       index = intensity_lut[j];
      
       if( i%2==mod_lstart) {
	 lut_colorcell_defs[i].red   = (unsigned short) (red_lut[red[index]]<<8) ;
	 lut_colorcell_defs[i].green = (unsigned short) (green_lut[green[index]]<<8) ;
	 lut_colorcell_defs[i].blue  = (unsigned short) (blue_lut[blue[index]]<<8) ;
       } else {
	 lut_colorcell_defs[i].red   = (unsigned short) 0xfffffff;
	 if( index < 50 )
	   background_index = ncolors-1-50;
	 else background_index = ncolors-1-index;
	 lut_colorcell_defs[i].green = (unsigned short) (green_lut[green[background_index]]<<8) ;
	 lut_colorcell_defs[i].blue  = (unsigned short) (blue_lut[blue[background_index]]<<8) ;
       }
       lut_colorcell_defs[i].flags = DoRed | DoBlue | DoGreen;
     }
   }
   Tcl_GetInt(interp,Tcl_GetVar(interp,"powPseudoImages",TCL_GLOBAL_ONLY),
	    &pseudoImages);
#if !(defined(__WIN32__) || defined(macintosh))
   if(pseudoImages) {
     XStoreColors(disp,cmap,&lut_colorcell_defs[lut_start],ncolors) ;
     XFlush(disp) ;
   }
#endif
} /* end put_lut */

int AllocateColorTable(PictColorTable **colorTable,Display *disp, 
		       Colormap cmap,int colormap_level,int ncolors,
		       int lut_start,char atom)
{
  int color_nb;
  int i,r;

  /* Allocate memory */
  (*colorTable) = (PictColorTable*)ckalloc(sizeof(PictColorTable));
  if((*colorTable) == NULL) {
    (void)fprintf(stderr,"ImgPictGet: Could not allocate memory\n");
    return 0;
  }

  /* store values */
  (*colorTable)->display = disp;
  (*colorTable)->colormap = cmap;
  (*colorTable)->colormap_level = colormap_level;
  (*colorTable)->ncolors = ncolors;
  (*colorTable)->lut_start = lut_start;
  (*colorTable)->atom =  atom;
  (*colorTable)->refCount = 1;
	 
  color_nb = ncolors-1;
	  
  /* load linear intensity lookup table */
  for (i=0; i<ncolors; i++) {
    (*colorTable)->intensity_lut[i] = i;
  }
  /* load linear red green blue lookup tables */
  for (i=0; i<MAX_COLORS; i++) {
    (*colorTable)->red_lut[i] = i;
    (*colorTable)->green_lut[i] = i;
    (*colorTable)->blue_lut[i] = i;
  }
  for (i = 0; i < MAX_COLORS; ++i) {
    r = (double)i*(double)color_nb/(double)(MAX_COLORS-1)+lut_start;
    (*colorTable)->redValues[i] = lut_colorcell_defs[r].pixel;
  }
 
  /* Load the gray color pattern */
  gray(disp,cmap,ncolors,lut_start,False,
       (*colorTable)->red,
       (*colorTable)->green,
       (*colorTable)->blue, 
       (*colorTable)->intensity_lut, 
       (*colorTable)->red_lut,  
       (*colorTable)->green_lut, 
       (*colorTable)->blue_lut);

  return 1;
} /* end AllocateColorTable */
